#!/usr/bin/env python3
# -*- coding: utf-8 -*-

import argparse
import random
import sys
import os
import subprocess
import numpy
import collections
import _pickle as pickle
import tensorflow as tf
import datetime
import dateutil.relativedelta
import time
import logging
from threading import Thread
import multiprocessing
import math
import shutil

import tflib
import tflib.linear
import tflib.conv1d

NOISE_LEVEL = None

# Color classes to print in bash/shell
class bcolors:
    BLUE   = '\033[94m'
    GREEN  = '\033[92m'
    ORANGE = '\033[93m'
    RED    = '\033[91m'
    ENDC   = '\033[0m'

# Parse command-line arguments
def parse_args():
    parser = argparse.ArgumentParser()
    parser.add_argument('--training-data',
                        type=str,
                        required=True,                    
                        help='Path to training data (UTF-8 encoded!)')
    parser.add_argument('--dictionaries',
                        type=str,                   
                        help='Path to dictionary directory (UTF-8 encoded!)')
    parser.add_argument('--output',
                        type=str,
                        required=True,
                        help='Path to output directory')
    parser.add_argument('--save-intervall',
                        type=int,
                        default=1000,
                        help='Save after n iterations (default: 1000)')
    parser.add_argument('--batch-size',
                        type=int,
                        default=64,
                        help='Batch size, which represents the number of passwords from the training set that propagate through the GAN at each step of the optimizer (default: 64)')
    parser.add_argument('--iterations',
                        type=int,
                        default=199000,
                        help='Number of training iterations, which indicates how many times the GAN invokes its forward step and its back-propagation step. In each iteration, the GAN runs one generator iteration and one or more discriminator iterations (default: 199000)')
    parser.add_argument('--discriminator-iterations',
                        type=int,
                        default=10,
                        help='Number of discriminator iterations per generator iteration, which indicates how many iterations the generator performs in each GAN iteration (default: 10)')
    parser.add_argument('--layer',
                        type=int,
                        default=5,
                        help='Number of residual layers for both the generator and the discriminator (default: 5)')
    parser.add_argument('--dimensionality',
                        type=int,
                        default=128,
                        help='Model dimensionality, which represents the number of dimensions (weights) for each convolutional layer (default: 128)')
    parser.add_argument('--gradient-penalty',
                        type=int,
                        default=10,
                        help='Gradient penalty coefficient, which specifies the penalty applied to the norm of the gradient of the discriminator with respect to its input (default: 10)')
    parser.add_argument('--output-length',
                        type=int,
                        default=10,
                        help='Output sequence length, which indicates the maximum length of the strings generated by the generator (default: 10)')
    parser.add_argument('--noise-size',
                        type=int,
                        default=128,
                        help='Size of the input noise vector (seed) which determines how many random bits are fed as input to G for the purpose of generating samples (default: 128)')
    parser.add_argument('--learning-rate',
                        type=float,
                        default=0.001,
                        help='(Adam optimizer\'s hyper parameters) Learning rate, i.e., how quickly the weights of the model are adjusted (default: 0.001)')
    parser.add_argument('--beta1',
                        type=float,
                        default=0.5,
                        help='(Adam optimizer\'s hyper parameters) Coefficient Beta1, which specifies the decaying rate of the running average of the gradient (default: 0.5)')
    parser.add_argument('--beta2',
                        type=float,
                        default=0.9,
                        help='(Adam optimizer\'s hyper parameters) Coefficient Beta2, which specifies the decaying rate of the running average of the square of the gradient (default: 0.9)')
    parser.add_argument('--gpu',
                        type=int,
                        default=0,
                        help='Index of the GPU to use (if existent). You can retrieve them via `nvidia-smi` (default: 0)')
    parser.add_argument('-v',
                        action='store_true',
                        help='Enable verbose printing and logging (CRITICAL)')
    parser.add_argument('-vv',
                        action='store_true',
                        help='Enable verbose printing and logging (CRITICAL, ERROR)')
    parser.add_argument('-vvv',
                        action='store_true',
                        help='Enable verbose printing and logging (CRITICAL, ERROR, WARNING)')
    parser.add_argument('-vvvv',
                        action='store_true',
                        help='Enable verbose printing and logging (CRITICAL, ERROR, WARNING, INFO)')
    parser.add_argument('-vvvvv',
                        action='store_true',
                        help='Enable verbose printing and logging (CRITICAL, ERROR, WARNING, INFO, DEBUG)')
    args = parser.parse_args()
    return args

def set_log_level(loglevel=None):
    global NOISE_LEVEL 
    if loglevel[4]:
        logging_level = logging.DEBUG
        NOISE_LEVEL = 'DEBUG'
        os.environ['TF_CPP_MIN_LOG_LEVEL'] = '0'
    elif loglevel[3]:
        logging_level = logging.INFO
        NOISE_LEVEL = 'INFO'
        os.environ['TF_CPP_MIN_LOG_LEVEL'] = '1'
    elif loglevel[2]:
        logging_level = logging.WARNING
        NOISE_LEVEL = 'WARNING'
        os.environ['TF_CPP_MIN_LOG_LEVEL'] = '2'
    elif loglevel[1]:
        logging_level = logging.ERROR
        NOISE_LEVEL = 'ERROR'
        os.environ['TF_CPP_MIN_LOG_LEVEL'] = '3'
    elif loglevel[0]:
        logging_level = logging.CRITICAL
        NOISE_LEVEL = 'CRITICAL'
        os.environ['TF_CPP_MIN_LOG_LEVEL'] = '4'
    else:
        logging_level = None
        NOISE_LEVEL = None
        os.environ['TF_CPP_MIN_LOG_LEVEL'] = '5'
    return logging_level  

# Log message
def log(LEVEL=None, MSG=None, LINEEND=None):
    global NOISE_LEVEL 
    
    levels = {'debug': 0, 'info': 1, 'warning': 2, 'error': 3, 'critical': 4}
    
    if LEVEL is None or MSG is None or NOISE_LEVEL is None:
        return
    
    if LEVEL.lower() == 'debug':
        logging.debug(MSG.strip())
    elif LEVEL.lower() == 'info':
        logging.info(MSG.strip())
    elif LEVEL.lower() == 'warning':
        logging.warning(MSG.strip())
    elif LEVEL.lower() == 'error':
        logging.error(MSG.strip())
    elif LEVEL.lower() == 'critical':
        logging.critical(MSG.strip())
      
    # Maybe disable this and use logging to file only
    if levels[NOISE_LEVEL.lower()] <= levels[LEVEL.lower()]: print('(%s) [%s] %s' % (time.asctime(), LEVEL, MSG), end=LINEEND if LINEEND else '\n')
    
# Create output folder if it does not exist yet and subfolders
def setup_folders(opath=None):
    if opath is None:
        raise ValueError('opath was None!')
    
    if not os.path.isdir(opath):
        os.makedirs(opath)
        
    if not os.path.isdir(os.path.join(opath, 'dictionaries')):
        os.makedirs(os.path.join(opath, 'dictionaries'))
        
    if not os.path.isdir(os.path.join(opath, 'passwords')):
        os.makedirs(os.path.join(opath, 'passwords'))

    if not os.path.isdir(os.path.join(opath, 'saved')):
        os.makedirs(os.path.join(opath, 'saved'))

    if not os.path.isdir(os.path.join(opath, 'samples')):
        os.makedirs(os.path.join(opath, 'samples'))

    if not os.path.isdir(os.path.join(opath, 'logs')):
        os.makedirs(os.path.join(opath, 'logs'))
   
def parse_dictionary(path=None, file=None, olength=0, dictionaries=None):
    entries = []
    file_path = file if os.path.isfile(file) else os.path.join(path, file)
    with open(file_path, 'r') as dictionary:
        entries = dictionary.read().splitlines()
        # Filter out words longer than output length since these words cannot appear in the passwords
        entries = [entry for entry in entries if len(entry) <= olength]
        entries.sort(key = lambda s: len(s))
        entries = list(reversed(entries))
        dictionaries[''.join(file.split('.')[:-1])] = entries

# Load training data by sorting out passwords which are too long or cannot be parsed properly
# Also map data from dictionary
def parse_file(pfile=None, dfile=None, opath=None, olength=None, placeholder=None):
    if pfile is None or olength is None or placeholder is None:
        raise ValueError('Either pfile, olength or placeholder were None!')
    
    if not os.path.isfile(pfile):
        log("CRITICAL", "Input file does not exist! Exiting.")
        sys.exit(1)
    
    changed = [True, False]
    
    # Load saved passwords if nothing changed
    if os.path.isfile(os.path.join(opath, 'passwords', os.path.basename(pfile))):
       passwords = load(opath=opath, passwords=True)
       changed[0] = False
    else:
        shutil.copy2(pfile, os.path.join(opath, 'passwords', os.path.basename(pfile)))
        passwords      = []
        try:
            num_lines      = int(subprocess.check_output(['/usr/bin/wc', '-l', pfile]).split()[0])
        except:
            log("CRITICAL", "/usr/bin/wc not found! Exiting.")
            sys.exit(1)
        count_accepted = 0
        count_skipped  = 0
        
        with open(pfile, 'r', encoding='utf-8') as training_file:
            for password in training_file:
                password = password.strip() 
                if password: # Skip empty lines
                    if not password.isdigit(): # Skip number-only lines
                        password = tuple(password)
                        if len(password) <= olength:
                            passwords.append(password + ( (placeholder,)*(olength-len(password))))
                            count_accepted = count_accepted + 1
                        else:
                            count_skipped = count_skipped + 1
                        log("DEBUG", "Parsing passwords: %s%d (Accepted)%s / %s%d (Skipped)%s / %s%d (Total)%s %s" % (bcolors.GREEN, count_accepted, bcolors.ENDC, bcolors.ORANGE, count_skipped, bcolors.ENDC, bcolors.BLUE, num_lines, bcolors.ENDC, ' ' * 20), "\r")
                    else:
                        count_skipped = count_skipped + 1
                else:
                    count_skipped = count_skipped + 1
        log("DEBUG", "Parsed passwords: %s%d (Accepted)%s / %s%d (Skipped)%s / %s%d (Total)%s %s" % (bcolors.GREEN, count_accepted, bcolors.ENDC, bcolors.ORANGE, count_skipped, bcolors.ENDC, bcolors.BLUE, num_lines, bcolors.ENDC, ' ' * 20))
        save(opath=opath, passwords=passwords)
    
    dictionaries = {}
    if dfile:
        files = [dfile] if os.path.isfile(dfile) else [f for f in os.listdir(dfile) if os.path.isfile(os.path.join(dfile, f))]
        if [f for f in files if not os.path.isfile(os.path.join(opath, 'dictionaries', os.path.basename(f)))]:
            log("DEBUG", "Dictionaries found: %s" % (', '.join(files)))
            changed[1] = True
            tlist = []
            for file in files:
                shutil.copy2(file, os.path.join(opath, 'dictionaries', os.path.basename(file)))
                t = Thread(target=parse_dictionary, args=(dfile, file, olength, dictionaries))
                tlist.append(t)
                t.start()
            while tlist:
                tlist[0].join()
                tlist.remove(tlist[0])
            save(opath=opath, dictionaries=dictionaries)
        else:
            dictionaries = load(opath=opath, dictionaries=True)
    
    # TODO comment for debugging/uncomment for final version
    numpy.random.shuffle(passwords)
    
    # Nothing has changed so we can safely load the old stuff
    if not changed[0] and not changed[1]:
        filtered_lines = load(opath=opath, filtered_lines=True)
        numpy.random.shuffle(filtered_lines)
        char_map = load(opath=opath, char_map=True)
        char_map_inv = load(opath=opath, char_map_inv=True)
    else:
        # Check if any word from dictionaries is contained
        finished_passwords = []
        if dfile:
            found = []
            count = 0
            word_found = 0
            
            def check_dictionary(password, placeholder, dictionaries, found, finished_passwords):
                tmp_pw = password
                for dictionary in dictionaries:
                    for word in dictionaries[dictionary]:
                        if word in ''.join(tmp_pw).replace(placeholder, '') and len(word) > 1:
                            tmp_pw = tuple(''.join(tmp_pw).replace(word, ''))
                            found.append(word)
                finished_passwords.append(tmp_pw + ( (placeholder,)*(olength-len(tmp_pw))))
            
            tlist = []
            batches = 1
            for password in passwords:
                t = Thread(target=check_dictionary, args=(password, placeholder, dictionaries, found, finished_passwords))
                tlist.append(t)
                if len(tlist) >= multiprocessing.cpu_count() * 2:
                    log("DEBUG", "Checking dictionaries with %d threads (Batch: #%d/%d)          " % (len(tlist), batches, math.ceil(len(passwords)/multiprocessing.cpu_count()/2)), "\r")
                    for entry in tlist:
                        entry.start()
                    while tlist:
                        tlist[0].join()
                        tlist.remove(tlist[0])
                    batches = batches + 1
            log("DEBUG", "Checking dictionaries with %d threads (Batch: #%d/%d)          " % (len(tlist), batches, math.ceil(len(passwords)/multiprocessing.cpu_count()/2)))
            for entry in tlist:
                entry.start()
            while tlist:
                tlist[0].join()
                tlist.remove(tlist[0])
        else:
            found = []
        
        # Now to the chars
        # words = [tuple(f) + ( (placeholder,)*(olength-len(f))) for f in found] if finished_passwords else passwords
        words = [f for f in finished_passwords if ''.join(f).replace(placeholder, '') != ''] + [tuple(f) + ( (placeholder,)*(olength-len(f))) for f in found] if finished_passwords else passwords
        counts = collections.Counter(char for password in words for char in password)
        char_map = {'unk':0}
        char_map_inv = ['unk']
        counts = counts + collections.Counter(word for word in found) # Combine both lists of words and chars
        for char,count in counts.most_common(2048): # Still do this even when loaded from file to allow learning from multiple datainputs
            if char not in char_map:
                char_map[char] = len(char_map_inv)
                char_map_inv.append(char)
                
        filtered_lines = []
        for password in words:
            filtered_line = []
            for char in password:
                if char in char_map:
                    filtered_line.append(char)
                else:
                    filtered_line.append('unk')
            filtered_lines.append(tuple(filtered_line))
    return filtered_lines, char_map, char_map_inv

def softmax(logits, num_classes):
    return tf.reshape(
        tf.nn.softmax(
            tf.reshape(logits, [-1, num_classes])
        ),
        tf.shape(logits)
    )

def ResBlock(name=None, inputs=None, dim=None):
    return inputs + (0.3*tflib.conv1d.Conv1D(name+'.2', dim, dim, 5, tf.nn.relu(tflib.conv1d.Conv1D(name+'.1', dim, dim, 5, tf.nn.relu(inputs)))))

def Generator(noise_size=None, batch_size=None, output_length=None, dimensionality=None, layer=None, output_dim=None):
    if noise_size is None or batch_size is None or output_length is None or dimensionality is None or output_dim is None:
        raise ValueError('One of the arguments was None!')
    output = tf.reshape(tflib.linear.Linear('Generator.Input', 128, output_length * dimensionality, tf.random_normal(shape=[batch_size, noise_size])), [-1, dimensionality, output_length])
    for i in range(1, layer):
        output = ResBlock('Generator.%d' % i, output, dimensionality)
    output = softmax(tf.transpose(tflib.conv1d.Conv1D('Generator.Output', dimensionality, output_dim, 1, output), [0, 2, 1]), output_dim)
    return output

def Discriminator(inputs, output_length=None, dimensionality=None, layer=None, input_dim=None):
    output = tflib.conv1d.Conv1D('Discriminator.Input', input_dim, dimensionality, 1,  tf.transpose(inputs, [0,2,1]))
    for i in range(1, layer):
        output = ResBlock('Discriminator.%d' % i, output, dimensionality)
    output = tflib.linear.Linear('Discriminator.Output', output_length * dimensionality, 1, tf.reshape(output, [-1, output_length * dimensionality]))
    return output

# Save everything
def save(opath=None, passwords=None, dictionaries=None, filtered_lines=None, char_map=None, char_map_inv=None, session=None, sessionName=None):
    if opath is None:
        raise ValueError('opath was None!')
    
    if passwords:
        with open(os.path.join(opath, 'passwords.pickle'), 'wb') as f:
            pickle.dump(passwords, f)
            log("DEBUG", "Saved passwords")
            
    if dictionaries:
        with open(os.path.join(opath, 'dictionaries.pickle'), 'wb') as f:
            pickle.dump(dictionaries, f)
            log("DEBUG", "Saved dictionaries")
    
    if filtered_lines:
        with open(os.path.join(opath, 'filtered_lines.pickle'), 'wb') as f:
            pickle.dump(filtered_lines, f)
            log("DEBUG", "Saved filtered lines")
    
    if char_map:
        with open(os.path.join(opath, 'char_map.pickle'), 'wb') as f:
            pickle.dump(char_map, f)
            log("DEBUG", "Saved char map")
    
    if char_map_inv:
        with open(os.path.join(opath, 'char_map_inv.pickle'), 'wb') as f:
            pickle.dump(char_map_inv, f)
            log("DEBUG", "Saved inverted char map")
            
    if session and sessionName:
        saver = tf.train.Saver()
        saver.save(session, os.path.join(opath, 'saved', 'model_' + sessionName + '.ckpt'))
        
# Restore last session to continue from there
def load(opath=None, passwords=None, dictionaries=None, filtered_lines=None, char_map=None, char_map_inv=None, session=None):
    if opath is None:
        raise ValueError('opath was None!')
    
    if passwords:
        if os.path.isfile(os.path.join(opath, 'passwords.pickle')):
            with open(os.path.join(opath, 'passwords.pickle'), 'rb') as f:
                passwords = pickle.load(f)
                log("DEBUG", "Loaded passwords")
        return passwords
    
    if dictionaries:
        if os.path.isfile(os.path.join(opath, 'dictionaries.pickle')):
            with open(os.path.join(opath, 'dictionaries.pickle'), 'rb') as f:
                dictionaries = pickle.load(f)
                log("DEBUG", "Loaded dictionaries")
        return dictionaries
    
    if filtered_lines:
        if os.path.isfile(os.path.join(opath, 'filtered_lines.pickle')):
            with open(os.path.join(opath, 'filtered_lines.pickle'), 'rb') as f:
                filtered_lines = pickle.load(f)
                log("DEBUG", "Loaded filtered lines")
        return filtered_lines
    
    if char_map:
        if os.path.isfile(os.path.join(opath, 'char_map.pickle')):
            with open(os.path.join(opath, 'char_map.pickle'), 'rb') as f:
                char_map = pickle.load(f)
                log("DEBUG", "Loaded char map")
        return char_map
    
    if char_map_inv:
        if os.path.isfile(os.path.join(opath, 'char_map_inv.pickle')):
            with open(os.path.join(opath, 'char_map_inv.pickle'), 'rb') as f:
                char_map_inv = pickle.load(f)
                log("DEBUG", "Loaded inverted char map")
        return char_map_inv
  
# Dataset iterator
def inf_train_gen(passwords=None, batch_size=None, char_map=None):
    while True:
        numpy.random.shuffle(passwords)
        for i in range(0, len(passwords)-batch_size+1, batch_size):
            yield numpy.array([[char_map[c] for c in l] for l in passwords[i:i+batch_size]], dtype='int32')
            
# Generate samples
def generate_samples(session=None, fake_inputs=None, char_map=None, char_map_inv=None):
    if session is None or fake_inputs is None or char_map is None or char_map_inv is None:
        raise ValueError('One of the arguments was None!')
    samples = numpy.argmax(session.run(fake_inputs), axis=2)
    decoded_samples = []
    for i in range(0, len(samples)):
        decoded = []
        for j in range(0, len(samples[i])):
            decoded.append(char_map_inv[samples[i][j]])
        decoded_samples.append(tuple(decoded))
    return decoded_samples

# Run the training here
def run(args=None):
    global NOISE_LEVEL 
    if args is None:
        raise ValueError('No arguments supplied!')
    
    # Set up folder structure
    setup_folders(args.output)
    
    # Logging setup
    logging_level = set_log_level({0: args.v, 1: args.vv, 2: args.vvv, 3: args.vvvv, 4: args.vvvvv})
    logging.basicConfig(filename=os.path.join(args.output, 'logs', 'log'), filemode='a', format='(%(asctime)s) [%(levelname)s]: %(message)s', level=logging_level)
    
    # Log arguments
    log("DEBUG", "Arguments: %s)" % (str(args)))
    
    # Select which GPU to use
    log("DEBUG", "Setting GPU to id #%s" % (str(args.gpu)))
    os.environ["CUDA_VISIBLE_DEVICES"] = str(args.gpu)
    
    # Placeholder which is used to stretch passwords generated
    PLACEHOLDER="'"
    log("DEBUG", "Placeholder == %s" % (PLACEHOLDER))

    # Parse training data
    log("DEBUG", "Parsing training data and generating char maps")
    passwords, char_map, char_map_inv = parse_file(pfile=args.training_data, dfile=args.dictionaries, opath=args.output, olength=args.output_length, placeholder=PLACEHOLDER)
    save(opath=args.output, filtered_lines=passwords, char_map=char_map, char_map_inv=char_map_inv)
    
    # Reset tensorflow and start logger
    log("DEBUG", "Setting TensorFlow log level to %s" % (os.environ['TF_CPP_MIN_LOG_LEVEL']))
    log("DEBUG", "Resetting TensorFlow graph")
    tf.reset_default_graph()
    config = tf.ConfigProto()
    config.gpu_options.allow_growth = True

    real_inputs_discrete = tf.placeholder(tf.int32, shape=[args.batch_size, args.output_length], name="real_inputs_discrete")
    real_inputs          = tf.one_hot(real_inputs_discrete, len(char_map))
    fake_inputs          = Generator(args.noise_size, args.batch_size, args.output_length, args.dimensionality, args.layer, len(char_map))
    disc_real            = Discriminator(real_inputs, args.output_length, args.dimensionality, args.layer, len(char_map))
    disc_fake            = Discriminator(fake_inputs, args.output_length, args.dimensionality, args.layer, len(char_map))
    disc_cost            = tf.reduce_mean(disc_fake) - tf.reduce_mean(disc_real)
    gen_cost             = -tf.reduce_mean(disc_fake)
    alpha                = tf.random_uniform(shape=[args.batch_size,1,1], minval=0., maxval=1.)
    differences          = fake_inputs - real_inputs
    interpolates         = real_inputs + (alpha*differences)
    gradients            = tf.gradients(Discriminator(interpolates, args.output_length, args.dimensionality, args.layer, len(char_map)), [interpolates])[0]
    slopes               = tf.sqrt(tf.reduce_sum(tf.square(gradients), reduction_indices=[1,2]))
    gradient_penalty     = tf.reduce_mean((slopes-1.)**2)
    disc_cost           += args.gradient_penalty * gradient_penalty
    gen_params           = tflib.params_with_name('Generator')
    disc_params          = tflib.params_with_name('Discriminator')
    gen_train_op         = tf.train.AdamOptimizer(learning_rate=args.learning_rate, beta1=args.beta1, beta2=args.beta2).minimize(gen_cost, var_list=gen_params)
    disc_train_op        = tf.train.AdamOptimizer(learning_rate=args.learning_rate, beta1=args.beta1, beta2=args.beta2).minimize(disc_cost, var_list=disc_params)


    with tf.Session() as session:
        # Restore existing sessions
        old_iteration = 0
        try:
            loader = tf.train.Saver()
            # Get latest checkpoint in folder
            files = [os.path.join(args.output, 'saved', f) for f in os.listdir(os.path.join(args.output, 'saved')) if 'model' in f]
            files.sort(key=lambda x: os.path.getmtime(x))
            if files:
                last_checkpoint = '.'.join(os.path.basename(files[-1]).split('.')[:-1])
                old_iteration = int(last_checkpoint.split('.')[0].split('_')[1])
                loader.restore(session, os.path.join(args.output, 'saved', last_checkpoint))
                log("INFO", "Restored session from " + str(last_checkpoint))
        except Exception as e:
            log("WARNING", str(e))
            pass # Probably no session existed before

        session.run(tf.global_variables_initializer())
        gen = inf_train_gen(passwords, args.batch_size, char_map)
        
        # Logwriter
        writer = tf.summary.FileWriter(os.path.join(args.output, 'logs'), graph=tf.get_default_graph())

        for iteration in range(old_iteration + 0, old_iteration + args.iterations):
            log("DEBUG", "Current iteration: %d%s" % (iteration, ' ' * 20), "\r")

            # Train generator
            if iteration > 0:
                _ = session.run(gen_train_op) 

            # Train critic
            for i in range(0, args.discriminator_iterations):
                _data = gen.__next__()
                _disc_cost, _ = session.run([disc_cost, disc_train_op], feed_dict={real_inputs_discrete:_data})
            
            # Save current session, generate samples and print some informations each SAVE_INTERVALL
            if iteration % args.save_intervall == 0 and iteration > 0:
                save(opath=args.output, session=session, sessionName=str(iteration))
                
                samples = generate_samples(session, fake_inputs, char_map, char_map_inv)
                samples = [entry for entry in list(set(samples)) if len("".join(entry).replace(PLACEHOLDER, '')) <= args.output_length and len("".join(entry).replace(PLACEHOLDER, '')) >= args.output_length / 2] 
                while len(samples) < 50:
                    samples = samples + generate_samples(session, fake_inputs, char_map, char_map_inv)
                    samples = [entry for entry in list(set(samples)) if len("".join(entry).replace(PLACEHOLDER, '')) <= args.output_length and len("".join(entry).replace(PLACEHOLDER, '')) >= args.output_length / 2] 
                samples = samples[:49]
                with open(os.path.join(args.output, 'samples', 'samples_' + str(iteration) + '.txt'), 'w') as sample_file:
                    sample_file.writelines(["".join(sample).replace(PLACEHOLDER, '') + "\n" for sample in samples])
                    
                log("INFO", "Saved iteration: %u%s" % (iteration, ' ' * 20))
                log("INFO", "Generated samples: %s" % (', '.join(["".join(sample).replace(PLACEHOLDER, '') for sample in samples])))




if __name__ == '__main__':
    start_time = datetime.datetime.fromtimestamp(time.time())
    run(parse_args())
    end_time   = datetime.datetime.fromtimestamp(time.time())
    rd = dateutil.relativedelta.relativedelta (end_time, start_time)
    log("INFO", "\nFinished after: %d days, %d hours, %d minutes and %d seconds" % (rd.days, rd.hours, rd.minutes, rd.seconds))
